/*

Aley's DSK2SAD image converter, version 1.1

by (c) Aley Keprt, 1997-98

this is a C++ source to be compiled using Borland C++ 3.1 or compatible
send any extended versions to AleyKeprt@bigfoot.com

this file is provided "as is", use it freely for ANY purpose
send any changed versions back to the author: AleyKeprt@bigfoot.com
if you will use this source or its parts in another program, 
please remember to credit me there!

*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <alloc.h>


char *side1[8];
char tempname[75];


void save(FILE *file,int ofs) {
 int a,b;
 for(a=0;a<8;a++) for(b=0;b<5;b++)
	fwrite(&side1[a][b*10240+ofs],1,5120,file);
}


void main(int pcount,char *pstr[]) {
 int a,b;

 printf("\nAley's DSK to SAD converter v1.1\n");
 printf("===AleyKeprt@bigfoot.com========\n\n");

 if(pcount<2) {
	printf("usage: dsk2sad <source.dsk> [target.sad]\n\n");
	return;
 }

 //alokuje celkem 450KB pamti
 for(a=0;a<8;a++) {
	side1[a]=(char*)malloc(51200);
	if(!side1[a]) {
	 printf("Insufficient memory, more %iKB needed\n\n",(9-a)*50);
	 return;
	}
 }

 //zpracuje jmna soubor
 char *rname=pstr[1];
 char wname[65];
 strcpy(wname,(pcount<3)?pstr[1]:pstr[2]);
 a=strlen(wname);
 for(b=a-1;b>=0;b--) {
	if(wname[b]=='\\'||wname[b]=='.') break;
 }
 if(wname[b]=='.') wname[b+1]=0;
	else wname[a]='.',wname[++a]=0;
 strncat(wname,"sad",3);

 //jmna na velk psmena
 strupr(rname);
 strupr(wname);

 //temp soubor vytvo v adresi TEMP/TMP/TMPDIR
 strcpy(tempname,getenv("TEMP"));
 if(!tempname[0]) {
  strcpy(tempname,getenv("TMP"));
  if(!tempname[0]) strcpy(tempname,getenv("TMPDIR"));
 }
 strcat(tempname,"\\~~~~sad~");
 remove(tempname);

 printf("Converting %s to %s...",rname,wname);

 //oteve soubory
 FILE *rf,*wf,*temp;
 if(!(rf=fopen(rname,"rb"))) {
	printf("Error: Cannot open input file!\n\n");
	return;
 }

 //testuje typ souboru podle dlky
 fseek(rf,0,2);
 long fsize=ftell(rf);
 fseek(rf,0,0);
 if(fsize!=819200) {
	printf("Error: Input file isn't DSK format!\n\n");
	return;
 }

 if(!(wf=fopen(wname,"wb"))) {
	printf("Error: Cannot create target file!\n\n");
	return;
 }
 if(!(temp=fopen(tempname,"wb"))) {
	printf("Error: Cannot create temp file!\n\n");
	return;
 }

 //ulo hlaviku SAD souboru
 char id[]="Aley's disk backup\x02\x50\x0a\x08";
 fwrite(id,1,22,wf);

 //vlastn konverze
 for(b=0;b<2;b++) {
	for(a=0;a<8;a++) fread(side1[a],1,51200,rf);
	save(wf,0);
	save(temp,5120);
 }
 fclose(rf);

 //pilep temp soubor
 fclose(temp);
 if(!(temp=fopen(tempname,"rb"))) {
	printf("Error: Cannot open temp file!\n\n");
  remove(tempname);
	return;
 }
 for(a=0;a<8;a++) fread(side1[a],1,51200,temp);
 fclose(temp);
 remove(tempname);
 for(a=0;a<8;a++) fwrite(side1[a],1,51200,wf);
 fclose(wf);

 printf("done\n\n");
}
