/*

Aley's SAD2DSK image converter, version 1.1

by (c) Aley Keprt, 1997-98

this is a C++ source to be compiled using Borland C++ 3.1 or compatible
send any extended versions to AleyKeprt@bigfoot.com

this file is provided "as is", use it freely for ANY purpose
send any changed versions back to the author: AleyKeprt@bigfoot.com
if you will use this source or its parts in another program, 
please remember to credit me there!

*/

#include <stdio.h>
#include <string.h>
#include <alloc.h>


void main(int pcount,char *pstr[]) {
 int a,b;

 printf("\nAley's SAD to DSK converter v1.1\n");
 printf("===AleyKeprt@bigfoot.com========\n\n");

 if(pcount<2) {
	printf("usage: sad2dsk <source.sad> [target.dsk]\n\n");
	return;
 }

 //alokuje celkem 450KB pamti
 char *side1[9];
 for(a=0;a<9;a++) {
	side1[a]=(char*)malloc(51200);
	if(!side1[a]) {
	 printf("Insufficient memory, more %i KB could be allocated\n\n",(9-a)*50);
	 return;
	}
 }
 char *side2;
 side2=side1[8];

 //zpracuje jmna soubor
 char *rname=pstr[1];
 char wname[65];
 strcpy(wname,(pcount<3)?pstr[1]:pstr[2]);
 a=strlen(wname);
 for(b=a-1;b>=0;b--) {
	if(wname[b]=='\\'||wname[b]=='.') break;
 }
 if(wname[b]=='.') wname[b+1]=0;
	else wname[a]='.',wname[++a]=0;
 strncat(wname,"dsk",3);

 //jmna na velk psmena
 strupr(rname);
 strupr(wname);

 printf("Converting %s to %s\n",rname,wname);

 //oteve zdrojov soubor
 FILE *rf,*wf;
 if(!(rf=fopen(rname,"rb"))) {
	printf("Error: Cannot open input file!\n\n");
	return;
 }

 //formt disku
 char id[19];
 fread(id,1,18,rf);
 id[18]=0;
 if(strcmp(id,"Aley's disk backup")) {
	printf("Error: Input file isn't SAD format!\n\n");
	return;
 }

 struct {
	char sides,tracks,sectors,sectsize;
 } form,corform={2,80,10,512/64};

 fread(&form,1,4,rf);
 printf("Disc format: %isid,%itrk,%isec/%ib\n",
	form.sides,form.tracks,
	form.sectors,form.sectsize*64);
 if(*(long*)(&form)!=*(long*)(&corform)) {
	printf("This disc format cannot be converted to DSK image file!\n\n");
	return;
 }

 //zalo clov soubor
 if(!(wf=fopen(wname,"wb"))) {
	printf("Error: Cannot create target file!\n\n");
	return;
 }

 //nahraje side A do bufferu
 for(a=0;a<8;a++) fread(side1[a],1,51200,rf);

 //nahrv postupn side B a hned to hz na vstup
 for(a=0;a<8;a++) {
	fread(side2,1,51200,rf);
	for(b=0;b<10;b++) {
	 fwrite(&(side1[a][5120*b]),1,5120,wf);
	 fwrite(&(side2   [5120*b]),1,5120,wf);
	}
 }

 printf("done.\n\n");
 fclose(rf);
 fclose(wf);
}
